//
// Created by martin on 11.04.25.
//

#ifndef TESTANIMDATA_H
#define TESTANIMDATA_H

#include "AnimGraph/AnimGraphData.h"
#include "AnimGraph/SyncTrack.h"
#include "ozz/animation/offline/skeleton_builder.h"
#include "ozz/animation/runtime/animation.h"
#include "ozz/animation/runtime/skeleton.h"

namespace TestAnimData {

struct SingleBoneSkeleton {
  SingleBoneSkeleton();

  ozz::unique_ptr<ozz::animation::Skeleton> skeleton = nullptr;

  ozz::unique_ptr<ozz::animation::Animation> animation_translate_x = nullptr;
  AnimationResource animation_translate_x_resource;
  SyncTrack animation_translate_x_sync_track = {};

  ozz::unique_ptr<ozz::animation::Animation> animation_translate_y = nullptr;
  AnimationResource animation_translate_y_resource;
  SyncTrack animation_translate_y_sync_track = {};

  bool SaveSkeleton(const char* filename, ozz::animation::Skeleton* skeleton);
  bool SaveAnimation(
      const char* filename,
      ozz::animation::Animation* animation);
};

}  // namespace TestAnimData

#endif  //TESTANIMDATA_H
